#include <algorithm>
#include <stdlib.h>
#include <math.h> 
#include <vector>
#include <typeinfo>
#include <R.h>
#include <Rinternals.h>

using namespace std;

extern "C"{


	SEXP boundsmod(SEXP bounds, SEXP val){
		double* rbounds = REAL(bounds);
		double* rval = REAL(val);
		int sizeb = length(bounds)/4;
		int sizev = length(val);

		SEXP boundsout;
	    PROTECT(boundsout = allocVector(REALSXP, sizeb*2));
	    double* rboundsout = REAL(boundsout);

	    for( int i = 0; i < sizeb; i++){
	    	int help = 0;
	    	rboundsout[2 * i] = rval[sizev - 1];
	    	rboundsout[2 * i + 1] = rval[0];
	    	for( int j = 0; j < sizev; j ++){
	    		if(rbounds[4*i + 2] <= rval[j] && rbounds[4*i + 3] >= rval[j]){
	    		help =1;
	    		rboundsout[2 * i] = min(rboundsout[2 * i], rval[j]);
	    		rboundsout[2 * i + 1] = max(rboundsout[2 * i + 1], rval[j]);
	    		}
	    	}
	    	if(help == 0){
	 
	    		rboundsout[2 * i] = rval[sizev - 1] * 10;
	    		rboundsout[2 * i + 1] = rval[sizev - 1] * 10;
	    	}
	    }



	    UNPROTECT(1);
	return(boundsout);

	}

	SEXP boundsstart(SEXP boundslr){
		int* rboundslr = INTEGER(boundslr);
		int sizeb = length(boundslr)/2;

		SEXP start;
		PROTECT(start = allocVector(INTSXP, rboundslr[2*sizeb - 1]));
		int* rstart = INTEGER(start);

		int i = 1;
		rstart[0] = 0;
		for( int j = 0; j < sizeb -1; j++){
			if(rboundslr[2*(j+1)]> rboundslr[2*j]){
				rstart[i] = j+1;
				i++;
			}
		}


		UNPROTECT(1);
		return(start);
	}

}
