library(slamR)

omega <- c(0.11, 0.29, 0.6)
m = 3
al <- sort( c(10,20,30))
a1 = al[1]
a2 = al[2]
no = 150
f <- cbind(rep(c(a1, a1, a2, a1, a2, a2, a1, a1, a1,  a1, a1, a1,  a1, al[3], a1, a2, a1, a1,  a2, a1, a1), each = no),
          rep(c(a1, a1, al[3],  a1, a1,  a1,  a1, a2,a2, a1, a1, a1,  a1, a1, a1, a1,  a1, a2, al[3],  a1, a1), each = no),
          rep(c(a1, a1, a2, a1, a1,  a1,  a1, a1, a1,  a1, a2, a2, a1, al[3], a1, a1,  a1, a1,  al[3],  a1, a1), each = no))
g <- colSums( t(f) * omega)
n <- length(g)
lambda <- 150 / n * 0.5

set.seed(1)
y <- g + 1 * rnorm(length(g))

ci2 <- confOmega(y, al = al, m = m, lambdaS = lambda, lambda = lambda, alpha = 0.1)
omegaEst2 <- round( (ci2$lower + ci2$upper) / sum(ci2), 2)

stopifnot(all(ci2 >= 0 & ci2 <= 1))
stopifnot(all( ci2$lower <= ci2$upper ))
stopifnot(length(omegaEst2) == m)

sm2 <- estSources(y, omega = omegaEst2, al = al, beta = 0.01, confband = TRUE, lambda = lambda)

stopifnot( all(is.element(unique( sm2$souces ), al ) ) )
stopifnot( all( dim(sm2$sources) == c( length(y), m) ) )

cb2 <- attr(sm2, "confBand")

stopifnot(length(cb2) == 2)
stopifnot(length(cb2[[1]]) == n)
stopifnot(all( is.element(unlist(cb2[[1]]), 1 : dim(cb2[[2]])[1] )))
stopifnot(all( sapply( cb2[[1]], length) > 0 ))

ans2 <- slamR(y, al = al, m = m, lambdaS = lambda, lambda = lambda, confreg = TRUE, confband = TRUE, alpha = 0.1)

cb <- attr(ans2, "confBand")
ci <- attr(ans2, "confReg")

stopifnot(length(ans2$omega) == m)
stopifnot(all(ans2$omega >= 0 & ans2$omega <= 1))
stopifnot( all(is.element(unique( ans2$souces ), al ) ) )
stopifnot( all( dim(ans2$sources) == c( length(y), m) ) )

stopifnot(length(cb) == 2)
stopifnot(length(cb[[1]]) == n)
stopifnot(all( is.element(unlist(cb[[1]]), 1 : dim(cb[[2]])[1] )))
stopifnot(all( sapply( cb[[1]], length) > 0 ))
stopifnot(all(ci == ci2))


rm(.Random.seed)

